<?php
/*
Plugin Name: WP Quote Tweets
Version: 1.1.1
Plugin URI:  http://0xtc.com/2009/06/18/wordpress-plugin-wp-quote-tweets.xhtml
Description: Allows authors to quote Twitter updates in posts or pages using a simple shortcode. [quotetweet tweetid=123456789]. The tweetid can be found in the URL of the tweet that is to be quoted.
Contributors: 0xtc
Author: Tanin Ehrami
Author URI: http://0xtc.com/
Stable tag: trunk
*/

function wp_quote_tweet($att,$content=null){
	extract	(shortcode_atts(array('tweetid'=>'0'), $att));
	if ($tweetid==0){return false;}
	$TwitterCacheDir = dirname(__FILE__).'/cache/';
	$filename = $TwitterCacheDir . 'twitter.'.$tweetid.'.cache';
	if (file_exists($filename)) {
		$filedate = filemtime($filename);
		$FileAge = time() - $filedate;
		if ($FileAge < 86400){
			return file_get_contents($filename);
		}
	}
	$statuses = wp_quote_tweet_getTwitterStatus($tweetid);
	if ($statuses==false){return false;}

	$is_first = true;
	$r_content = '';
	foreach ($statuses as $status) {
		$r_content .= 		' 
							<div class="tweetquote">
								<span class="controls">
									<a href="http://twitter.com/home?status=@'.$status['UserName'].'%20&amp;in_reply_to_status_id='.$status['StatusID'].'&amp;in_reply_to='.$status['UserName'].'" title="Reply to '.$status['Name'].'" rel="external" class="reply">
										Reply
									</a>
									<a href="http://twitter.com/home?status=RT @'.$status['UserName'].'%20'.urlencode(strip_tags($status['message'])).'" title="Reply to '.$status['Name'].'" rel="external" class="retweet">
										Retweet
									</a>
								</span>
								<p class="tweetitem">
									<a href="http://twitter.com/'.$status['UserName'].'" title="'.$status['Name'].'" class="quoting_pic" rel="external">
										<img src="'.$status['profile_image_url'].'" alt="'.$status['UserName'].'" />
									</a> 
									<span class="leftdoublequote">&ldquo;</span> 
									<span class="quoting_msg">
										'.$status['message']."\r\n".'
									</span>
									<span class="rightdoublequote">&rdquo;</span> 
									<span class="tweetinfo">
										By <a href="http://twitter.com/'.$status['UserName'].'" title="Twitter page : '.$status['Name'].'" rel="external">'. $status['Name'].'</a> 
										on <a href="http://twitter.com/'.$status['UserName'].'/status/'.$status['StatusID'].'" rel="external">'.$status['time'].'</a>';
		if ($status['in_reply_to_status_id']<>''){
			$userinfo = wp_quote_tweet_getTwitterUser($status['in_reply_to_user_id']);
		$r_content .= 		'
										in reply to <a href="http://twitter.com/'.$userinfo->screen_name.'/status/'.$status['in_reply_to_status_id'].'" rel="external">'.$userinfo->name.'</a>';
		}
		
		$r_content .= 		' 
									</span>
								</p>
								<div class="tweetclear"></div>
							</div>
';
	}
	file_put_contents($filename, $r_content);
	return $r_content;
}

function wp_quote_tweet_formatTweetContent ($tweet){
	$search = array('&'); 
	$replace = array('&amp;');
	$tweet = str_replace($search, $replace, $tweet);
	$tweet = preg_replace("/http:\/\/(.*?)[^ ]*/"	, 	'<a href="\\0" rel="external">\\0</a>', $tweet);
	$tweet = preg_replace("(@([a-zA-Z0-9_]+))"		,	"<a href=\"http://www.twitter.com/\\1\" rel=\"external\">\\0</a>", $tweet);
	$tweet = preg_replace('/\#(\w+)/'				, 	"<a href='http://search.twitter.com/search?q=$1' rel='external'>#$1</a>", $tweet);
	return $tweet;
}

function wp_quote_tweet_getTwitterStatus($tweetID) {
	$url = sprintf("http://twitter.com/statuses/show/%s.xml", $tweetID);
	$status = new SimpleXMLElement(file_get_contents($url));
	$tweets = array();
	$message='';
	$message			= wp_quote_tweet_formatTweetContent($status->text);
	$time 				= wp_quote_tweet_niceTime(strtotime(str_replace("+0000", "", $status->created_at)));
	$time 				= date("j-n-Y H:i:s",strtotime(str_replace(" +0000", "", $status->created_at )));
	$profile_image_url	= $status->user->profile_image_url;
	$StatusID			= $status->id;
	$TweetUserName		= $status->user->screen_name;
	$TweeterName		= $status->user->name;
	$tweets[] = array(
		'in_reply_to_status_id'	=>	$status->in_reply_to_status_id,
		'in_reply_to_user_id'	=>	$status->in_reply_to_user_id,
		'message' 				=> 	$message,
		'time' 					=> 	$time,
		'profile_image_url'		=>	$profile_image_url,
		'StatusID'				=>	$StatusID,
		'UserName'				=>	$TweetUserName,
		'Name'					=>	$TweeterName);
	if ($TweetUserName==''){
		return false;
	}
	return $tweets;
}

function wp_quote_tweet_niceTime($time) {
	$delta = time() - $time;
	if ($delta < 60) { return 'less than a minute ago.';
		} else if ($delta < 120) { return 'about a minute ago.';
		} else if ($delta < (45 * 60)) { return floor($delta / 60) . ' minutes ago.';
		} else if ($delta < (90 * 60)) { return 'about an hour ago.';
		} else if ($delta < (24 * 60 * 60)) { return 'about ' . floor($delta / 3600) . ' hours ago.';
		} else if ($delta < (48 * 60 * 60)) { return '1 day ago.';
		} else { return floor($delta / 86400) . ' days ago.';
	}
}

function wp_quote_tweet_getTwitterUser($userID){
	$url = sprintf('http://twitter.com/users/show.xml?user_id='.$userID);
	$userinfo = new SimpleXMLElement(file_get_contents($url));
	return $userinfo;
}

function wp_quote_tweet_add_header(){
	$pluginPath = get_bloginfo('wpurl').'/wp-content/plugins/wp-quote-tweets/';
	$cssline = "\r\n\t<!-- WP Quote Tweets 1.1.1 -->\r\n\t<link rel=\"stylesheet\" href=\"".$pluginPath."wp_quotetweets.css\" type=\"text/css\" media=\"screen\" />\n";
	echo $cssline;
}

add_action		('wp_head', 'wp_quote_tweet_add_header');
add_shortcode	('quotetweet', 'wp_quote_tweet');
?>